/********************************************/
/*   Use MADS http://g2f.atari8.info/mads   */
/*   Mode: DLI (char mode)                  */
/********************************************/

scr48	equ %00111111	;screen 48b
scr40	equ %00111110	;screen 40b
scr32	equ %00111101	;screen 32b

cloc	equ $0014	;(1)
byt2	equ $0000	;(1) <$0100
byt3	equ $0100	;(1) >$00FF

ftmp	equ $80		;(2)
regA	equ ftmp+2	;(1)
regX	equ regA+1	;(1)
regY	equ regX+1	;(1)

hposp0	equ $D000
hposp1	equ $D001
hposp2	equ $D002
hposp3	equ $D003
hposm0	equ $D004
hposm1	equ $D005
hposm2	equ $D006
hposm3	equ $D007
sizep0	equ $D008
sizep1	equ $D009
sizep2	equ $D00A
sizep3	equ $D00B
sizem	equ $D00C

colpm0	equ $D012
colpm1	equ $D013
colpm2	equ $D014
colpm3	equ $D015
color0	equ $D016
color1	equ $D017
color2	equ $D018
color3	equ $D019
colbak	equ $D01A
gtictl	equ $D01B

chbase	equ $D409

;-- BASIC switch OFF
 org $2000
 lda #$ff
 sta $d301
 rts
 ini $2000

;-- MAIN PROGRAM
 org $2000

ant	ANTIC_PROGRAM scr,ant

scr	SCREEN_DATA

	ALIGN $0400
fnt	FONTS

	ALIGN $1000
	org *+$0300
pmg	SPRITES

main
;-- init PMG
 mva >pmg $d407		;missiles and players data address
 mva #3 $d01d		;enable players and missiles

 ift .def CHANGES	;if label CHANGES defined
 jsr save_color		;then save all colors and set value 0 for all colors
 eif

 lda:cmp:req 20		;wait 1 frame

 sei			;stop interrups
 mva #0 $d40e		;stop all interrupts
 mva #$fe $d301		;switch off ROM to get 16k more ram

 mwa #nmi $fffa		;new NMI handler

 mva #$c0 $d40e		;switch on NMI+DLI again

 ift .def CHANGES	;if label CHANGES defined
 jsr fade_in		;fade in colors
_lp lda $d20f		;wait to press any key; here you can put any own routine
 and #4
 bne _lp
 jsr fade_out		;fade out colors
 mva #0 $d01d		;PMG disabled
 mva #$ff $d301		;ROM switch on
 mva #$40 $d40e		;only NMI interrupts, DLI disabled
 cli			;IRQ enabled
 jmp ($a)		;jump to DOS
 els
null jmp dli1		;CPU is busy here, so no more routines allowed
 eif

;-- DLI PROGRAM

 ?old_dli equ *

dli1
 lda $d40b
 cmp #2
 bne dli1
 :3 sta $d40a
 DLINEW dli6

dli_start
dli6

 sta $d40a                   ;line=8
 lda #$42
 sta $d40a                   ;line=9
 sta hposp1
 DLINEW dli7

dli7

 sta $d40a                   ;line=16
 lda #$3F
 sta $d40a                   ;line=17
 sta hposp1
 lda #$6C
 sta $d40a                   ;line=18
 sta hposm1
 lda #$3D
 ldx #$74
 ldy #$6E
 sta $d40a                   ;line=19
 sta hposp1
 stx hposp3
 sty hposm1
c9 lda #$68
 sta colpm3
 sta $d40a                   ;line=20
 lda #$3C
 ldx #$6F
 ldy #$6D
 sta $d40a                   ;line=21
 sta hposp1
 stx hposm1
 sty hposm3
 lda #$70
 sta $d40a                   ;line=22
 sta hposm1
c10 lda #$7A
 ldx #$3A
 ldy #$71
 sta $d40a                   ;line=23
 sta color2
 stx hposp1
 sty hposm1
 lda >fnt+$400*$01
c11 ldx #$54
c12 ldy #$68
 sta $d40a                   ;line=24
 sta chbase
 stx color0
 sty color1
 lda #$3C
 sta hposp1
 lda #$6B
 sta $d40a                   ;line=25
 sta hposm1
c13 lda #$0C
 sta $d40a                   ;line=26
 sta colpm1
 lda #$03
 ldx #$37
 sta $d40a                   ;line=27
 sta sizep1
 stx hposp1
 sta $d40a                   ;line=28
 lda #$FC
 ldx #$54
 ldy #$9B
 sta $d40a                   ;line=29
 sta sizem
 stx hposm1
 sty hposm3
c14 lda #$0C
 sta colpm3
 DLINEW dli8

dli8

 sta $d40a                   ;line=32
 sta $d40a                   ;line=33
 lda #$5A
 sta $d40a                   ;line=34
 sta hposp0
 lda #$76
 ldx #$9D
 sta $d40a                   ;line=35
 sta hposp3
 stx hposm3
 sta $d40a                   ;line=36
 sta $d40a                   ;line=37
 lda #$5C
 sta $d40a                   ;line=38
 sta hposm2
 sta $d40a                   ;line=39
 lda #$35
 ldx #$75
 ldy #$9E
 sta $d40a                   ;line=40
 sta hposp1
 stx hposp3
 sty hposm3
 lda #$38
 sta $d40a                   ;line=41
 sta hposp1
 lda #$01
 ldx #$39
 ldy #$9F
 sta $d40a                   ;line=42
 sta sizep1
 stx hposp1
 sty hposm3
 lda #$74
 sta $d40a                   ;line=43
 sta hposp3
 sta $d40a                   ;line=44
 lda #$A0
 sta $d40a                   ;line=45
 sta hposm3
 lda #$52
 ldx #$A1
 sta $d40a                   ;line=46
 sta hposm1
 stx hposm3
 lda #$01
 ldx #$83
 ldy #$55
 sta $d40a                   ;line=47
 sta sizep3
 stx hposp3
 sty hposm2
 lda >fnt+$400*$02
 ldx #$8F
 sta $d40a                   ;line=48
 sta chbase
 stx hposm0
 sta $d40a                   ;line=49
 lda #$82
 sta $d40a                   ;line=50
 sta hposp3
 DLINEW dli9

dli9

 lda #$00
 ldx #$62
c15 ldy #$68
 sta $d40a                   ;line=56
 sta sizep2
 stx hposp2
 sty colpm2
 sta $d40a                   ;line=57
 lda #$3C
 ldx #$A6
 sta $d40a                   ;line=58
 sta sizem
 stx hposm3
 sta $d40a                   ;line=59
 sta $d40a                   ;line=60
c16 lda #$54
 sta $d40a                   ;line=61
 sta colpm3
 DLINEW dli10

dli10

c17 lda #$14
 sta $d40a                   ;line=64
 sta color0
 lda #$00
 ldx #$8B
c18 ldy #$68
 sta $d40a                   ;line=65
 sta sizep3
 stx hposp3
 sty colpm3
c19 lda #$26
c20 ldx #$FA
 ldy #$85
 sta $d40a                   ;line=66
 sta color1
 stx color2
 sty hposm3
c21 lda #$68
 sta colpm0
 sta $d40a                   ;line=67
 sta $d40a                   ;line=68
 sta $d40a                   ;line=69
 lda #$61
 sta $d40a                   ;line=70
 sta hposp0
 DLINEW dli2


dli2
 lda >fnt+$400*$03
 sta $d40a                   ;line=72
 sta chbase
 DLINEW dli11

dli11

 lda #$67
 sta $d40a                   ;line=80
 sta hposp0
 DLINEW dli3

dli3
 lda >fnt+$400*$04
 sta $d40a                   ;line=96
 sta chbase
 DLINEW dli12

dli12

c22 lda #$00
c23 ldx #$08
c24 ldy #$00
 sta $d40a                   ;line=104
 sta color0
 sta color1
 stx color2
 sty color3
 lda #$01
 sta gtictl
 lda #$03
 sta sizep2
 sta sizep3
 lda #$FC
 sta sizem
 lda #$A4
 sta hposp2
 lda #$7C
 sta hposp3
 lda #$CC
 sta hposm1
 lda #$C4
 sta hposm2
 lda #$9C
 sta hposm3
c25 lda #$0C
 sta colpm2
 sta colpm3
 DLINEW dli13

dli13

 lda #$CD
 sta $d40a                   ;line=192
 sta hposm1
 jmp NmiQuit

;--

CHANGES

nmi
 sta regA
 stx regX
 sty regY

 bit $d40f
 bpl vbl

dliv jmp dli_start

vbl			;VBL routine
 sta $d40f		;reset NMI flag

 inc cloc		;little timer

 mwa #ant $d402		;ANTIC address program
 mva #scr40 $d400	;set new screen's width

;-- first line of screen initialization

 lda >fnt+$400*$00
 sta chbase
c0 lda #$00
 sta colbak
c1 lda #$14
 sta color0
c2 lda #$26
 sta color1
c3 lda #$FA
 sta color2
c4 lda #$54
 sta color3
 lda #$04
 sta gtictl
 lda #$00
 sta sizep0
 sta sizep1
 lda #$01
 sta sizep2
 lda #$03
 sta sizep3
 lda #$34
 sta sizem
 lda #$3F
 sta hposp0
 lda #$49
 sta hposp1
 lda #$B9
 sta hposp2
 lda #$72
 sta hposp3
 sta hposm0
 lda #$6B
 sta hposm1
 lda #$5E
 sta hposm2
 lda #$6A
 sta hposm3
c5 lda #$7A
 sta colpm0
c6 lda #$68
 sta colpm1
c7 lda #$0C
 sta colpm2
c8 lda #$FA
 sta colpm3

 mwa #dli_start dliv+1	;set the first address of DLI interrupt

;this area is for yours routines

NmiQuit
 lda regA
 ldx regX
 ldy regY
 rti

;--
 icl 'Getr4_OK.fad'

.macro SPRITES
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$08,$08,$04,$8C,$0C,$0C,$0C,$4D
 dta $00,$00,$00,$00,$00,$00,$00,$00,$40,$70,$70,$D0,$C0,$C0,$E0,$64
 dta $F4,$F4,$F4,$F4,$FC,$DC,$54,$60,$60,$20,$20,$00,$20,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$42,$01,$40,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C
 dta $00,$00,$00,$00,$00,$00,$00,$00,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
 dta $C0,$C0,$C0,$C0,$C0,$C0,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$F8,$F8,$F8,$F8,$F8,$F8,$F8,$F8
 dta $F8,$F8,$F8,$F8,$F8,$F8,$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F

 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$02,$04,$00,$08,$10,$00,$40
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$04,$02,$83,$41,$20,$10,$10,$08
 dta $04,$82,$40,$20,$10,$00,$04,$00,$40,$20,$04,$0C,$06,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$02,$0A,$10,$20,$00,$80
 dta $00,$04,$08,$10,$01,$02,$04,$0C,$18,$45,$0A,$47,$0D,$85,$0E,$85
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$00,$80,$80,$80,$80,$80
 dta $D0,$A0,$DC,$5E,$DC,$2E,$40,$00,$00,$00,$04,$04,$06,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$C0,$00,$00
 dta $00,$30,$38,$F8,$F8,$F8,$F0,$60,$42,$02,$02,$06,$06,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$40,$A0,$40,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 dta $FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$40,$40,$40,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$40,$00,$40,$40,$80,$80,$80,$82,$82
 dta $80,$80,$82,$87,$87,$07,$0F,$3F,$7E,$6C,$6E,$6E,$6E,$6E,$4E,$4E
 dta $4C,$8C,$44,$04,$00,$00,$00,$00,$00,$00,$1C,$04,$01,$04,$41,$12
 dta $07,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
 dta $3F,$3F,$3F,$3F,$3F,$3F,$3F,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 dta $FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 dta $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

.endm
 run main

 opt l-
 icl 'Getr4_OK.mac'

.macro ANTIC_PROGRAM
 dta $C4,a(:1),$84,$04,$84,$04,$04,$84,$84,$84,$84,$04,$84,$84,$70,$70,$02,$02,$02,$02,$02,$02,$02,$02,$82,$02,$02,$70,$70,$70,$70
 dta $41,a(:2)
.endm

.macro SCREEN_DATA
 ins 'Getr4_OK.scr'
.endm

.macro FONTS
 ins 'Getr4_OK.fnt'
.endm
